#include <array>
#include "canvas/Canvas.hpp"
#include "values/DnaManager.hpp"
class App
{

public:
  App() = default;
  ~App() = default;
  void init(int screenWidth, int screenHeight);
  void update();
  void draw();
  void deinit();

private:
  void upTex(Liked liked);

  int screenWidth, screenHeight;
  Canvas canvas;
  RenderTexture2D canvasTexure = {0};

  Rectangle dest;
  Rectangle likeBox;
  Rectangle disLikeBox;

  Unit unit;
  DnaManager manager;
};
